package data;

public class Lista {

	/*
	 * Numa lista o primeiro elemento que entra  o primeiro a sair no nosso
	 * contrututor teremos um elemento chamado head que ser o primeiro elemento
	 * da nossa lista .
	 */
	private Node head;

	public Lista() {
		this.head = null;
	}

	public void insert(Conta info) {
		if (this.head == null) {
			this.head = new Node(info);
		} else {
			Node aux = this.head;

			while (aux.getProx() != null) {
				aux = aux.getProx();
			}
			aux.setProx(new Node(info));
		}

	}

	/*
	 * Pra procurar a posio vazia para inserir, por exemplo pode-se fazer de
	 * vrias formas, algumas ajudaam no custo computacional. exemplo 1: 
	 * fazendo uma referencia para o final da lista(tail) exemplo 2: inserir
	 * sempre no incio da lista, ou seja desloca todos pro final e insere no
	 * comeo.
	 */
	public Conta search(int number) {
		Node aux = null;

		if (this.head != null) {
			aux = this.head;

			while ((aux != null) && (aux.getInfo().getNumber() != number)) {
				aux = aux.getProx();
			}

			if (aux == null) {
				throw new RuntimeException("Elemento não encontrado.");
			}

		} else {
			throw new RuntimeException("Lista vazia");
		}

		return aux.getInfo();
	}

	public void remove(int number) {

		if (this.head == null) {
			throw new RuntimeException("Lista vazia");
		} else if (this.head.getInfo().getNumber() == number) {
			this.head = this.head.getProx();
		} else {
			Node aux = this.head.getProx();
			Node prev = this.head;

			while ((aux != null) && (aux.getInfo().getNumber() != number)) {
				prev = aux;
				aux = aux.getProx();
			}

			if (aux != null) {
				prev.setProx(aux.getProx());
				aux = null;
			} else {
				throw new RuntimeException("Elemento não encontrado");
			}
		}
	}
}