package data;

public class Pilha{
	/* Pra trabalhar com uma pilha  necessrio criar um n chamado topo
	 * pois numa pilha o ultimo elemento a ser adicionado   o primeiro
	 * a sair.  
	 */

	private Node top;
	
	public Pilha(){
		this.top = null;
	}
	
	/*O mtodo push coloca o n no topo da pilha e setta o atributo prximo
	 * para o elemento que estava no topo, logo o que foi feito simplesmente
	 * foi: o "apontador" est apontando para o ltimo elemento adicionado
	 * no caso o elemento do topo e o atributo Prox de Prximo est apontando
	 * pro penltimo elemento da pilha. 
	 */
	
	public void push(Conta info){
		Node aux = new Node(info);

		aux.setProx(this.top);
		this.top = aux;
	}

	/*O mtodo pop retira o ltimo elemento adicionado no caso o elemento do 
	 * topo da pilha. 
	 *  preciso prestar ateno nos casos em que teremos, no caso no if
	 * temos a condio em que a pilha est vazia - note a excesso.
	 * No else ele faz com que o apontador do topo passe a apontar para o 
	 * o elemento Prox do topo. 
	 */
	public Conta pop(){
		Node aux = this.top;
		if(aux == null){
			throw new RuntimeException("Pilha vazia");
		}else{
			this.top = this.top.getProx();
		}

		return aux.getInfo();		
	} 
}